// ----------------------------------------
// Диалоговая панель с редактором текста
// и переключателями
// ----------------------------------------

#define STRICT
#include <windows.h>
#include "dlgtab.hpp"

// Прототипы функций
BOOL InitApp(HINSTANCE);
LRESULT CALLBACK _export WndProc(HWND, UINT, WPARAM, LPARAM);
BOOL    CALLBACK _export DlgProc(HWND, UINT, WPARAM, LPARAM);

// Имя класса окна
char const szClassName[]   = "DlgTabAppClass";

// Заголовок окна
char const szWindowTitle[] = "DlgTab Box Demo";

HINSTANCE hInst;

// =====================================
// Функция WinMain
// =====================================
#pragma argsused

int PASCAL
WinMain(HINSTANCE hInstance,
	HINSTANCE hPrevInstance,
	LPSTR     lpszCmdLine, 
	int       nCmdShow)   
{
  MSG  msg;   // структура для работы с сообщениями
  HWND hwnd;  // идентификатор главного окна приложения

  // Инициализируем приложение
  if(!InitApp(hInstance))
      return FALSE;

  hInst = hInstance;

  // После успешной инициализации приложения создаем
  // главное окно приложения
  hwnd = CreateWindow(
    szClassName,         // имя класса окна
    szWindowTitle,       // заголовок окна
    WS_OVERLAPPEDWINDOW, // стиль окна
    CW_USEDEFAULT,       // задаем размеры и расположение
    CW_USEDEFAULT,       // окна, принятые по умолчанию 
    CW_USEDEFAULT,
    CW_USEDEFAULT,
    0,                   // идентификатор родительского окна
    0,                   // идентификатор меню
    hInstance,           // идентификатор приложения
    NULL);               // указатель на дополнительные
			 // параметры
  // Если создать окно не удалось, завершаем приложение
  if(!hwnd)
    return FALSE;

  // Запускаем цикл обработки сообщений
  while(GetMessage(&msg, 0, 0, 0))
  {
    DispatchMessage(&msg);
  }
  return msg.wParam;
}

// =====================================
// Функция InitApp
// Выполняет регистрацию класса окна
// =====================================

BOOL
InitApp(HINSTANCE hInstance)
{
  ATOM aWndClass; // атом для кода возврата
  WNDCLASS wc;    // структура для регистрации
                  // класса окна
  wc.style = 0;
  wc.lpfnWndProc = (WNDPROC) WndProc;
  wc.cbClsExtra = 0;
  wc.cbWndExtra = 0;
  wc.hInstance = hInstance;
  wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
  wc.hCursor = LoadCursor(NULL, IDC_ARROW);
  wc.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1);
  wc.lpszMenuName = (LPSTR)NULL;
  wc.lpszClassName = (LPSTR)szClassName;

  // Регистрация класса
  aWndClass = RegisterClass(&wc);

  return (aWndClass != 0);
}

// =====================================
// Функция WndProc
// =====================================

LRESULT CALLBACK _export
WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
  switch (msg)
  {
    case WM_CREATE:
    {
      // Создаем модальную диалоговую панель
      DialogBox(hInst, "SELECT", hwnd, (DLGPROC)DlgProc);

      // После завершения работы диалоговой панели
      // завершаем работу приложения
      DestroyWindow(hwnd);
      return 0;
    }

    case WM_DESTROY:
    {
      PostQuitMessage(0);
      return 0;
    }
  }
  return DefWindowProc(hwnd, msg, wParam, lParam);
}

// =====================================
// Функция DldProc
// =====================================
#pragma argsused

BOOL CALLBACK _export
DlgProc(HWND hdlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
  switch(msg)
  {
    // Инициализация диалоговой панели
    case WM_INITDIALOG:
    {
      return TRUE;
    }

    case WM_COMMAND:
    {
      switch(wParam)
      {
        char Buffer[256];

        // Сообщение от кнопки "OK"
        case IDOK:
        {
          // Получаем строку из текстового редактора 
          GetDlgItemText(hdlg, IDC_NAME, Buffer, 80);

          lstrcat(Buffer, "\n\nДолжность:\n");

          // Определяем состояние переключателей
          // типа RadioButton
          if(IsDlgButtonChecked(hdlg, IDC_PROGRAMMER))
          {
            lstrcat(Buffer, "Программист");
          }
          else if(IsDlgButtonChecked(hdlg, IDC_ENGINIER))
          {
            lstrcat(Buffer, "Инженер");
          }
          else if(IsDlgButtonChecked(hdlg, IDC_SENGINIER))
          {
            lstrcat(Buffer, "Старший инженер");
          }

          lstrcat(Buffer, "\n\nЗнает языки:\n");

          // Определяем состояние переключателей
          // типа CheckBox
          if(IsDlgButtonChecked(hdlg, IDC_ENGLISH))
          {
            lstrcat(Buffer, "Английский\n");
          }
          if(IsDlgButtonChecked(hdlg, IDC_C))
          {
            lstrcat(Buffer, "Си\n");
          }
          if(IsDlgButtonChecked(hdlg, IDC_PASCAL))
          {
            lstrcat(Buffer, "Паскаль\n");
          }

          MessageBox(hdlg, Buffer, "Вы ввели", MB_OK);
          return TRUE;
        }

        // Отмена диалоговой панели.
        case IDCANCEL:
        {
          // Устанавливаем флаг завершения диалога
          EndDialog(hdlg, FALSE);
          return TRUE;
        }
      }
    }
  }
  return FALSE;
}
